#include <iostream.h>
#include <ctype.h>

#include "RJS/String.h"

class UpStr : public String {
public:
  UpStr()                           : String()    { update(); }
  UpStr(int n)                      : String(n)   { update(); }
  UpStr(char ch)                    : String(ch)  { update(); }
  UpStr(const char *s)              : String(s)   { update(); }
  UpStr(const char *s,int n)        : String(s,n) { update(); }
  UpStr(const String &s)            : String(s)   { update(); }
  UpStr &operator=(char ch)         { (String&) *this = ch; return *this; }
  UpStr &operator=(const char *s)   { (String&) *this = s;  return *this; }
  UpStr &operator=(const String &s) { (String&) *this = s;  return *this; }
  virtual void update();
};

void UpStr::update() 
{
	int l=length();
	char *p=cptr();
	while(l--) { 
		if (islower(*p)) *p=_toupper(*p);
		p++;
	}
}

int num_fail=0, num_pass=0;

#define Assert(cond) if (!(cond)) num_fail++,cerr << "Assert(" << __LINE__ << ") Failed." << endl;  else num_pass++;

void do_update(String *s)
{
cout << " do_update : " << (*s) << endl;
}

void main() 
{
UpStr u1("this is upper");
String::set_update(do_update);

cout << u1 << endl;
u1.at(" IS ") = " be ";
cout << u1 << endl;

//cout << "Number of tests that passed ==> " << num_pass << endl;
//cout << "Number of tests that failed ==> " << num_fail << endl;
}
